#!/usr/bin/perl
# 
# library - xml (sb xmlrpc parser)
# == scripted by Takuya Otani ========
# == copyright (C) SimpleBoxes 2004 ==

{
	my $aVersion_ = 0.04;
	# [ͻ] ====================================================================
	# XML-RPC ͽ
	# http://lowlife.jp/yasusii/stories/9.html
	# Movable Type ǻȤ XML-RPC API
	# http://www.na.rim.or.jp/~tsupo/program/blogTool/mt_xmlRpc.html
	# 
	# [XML-RPC API ] === sbform.pl Ȥ߹ =================================
	# if ($ENV{'CONTENT_TYPE'} eq 'text/xml' and $ENV{'REQUEST_METHOD'} eq 'POST') {
	# 	my $body;
	# 	my $check = read(STDIN, $body, $ENV{'CONTENT_LENGTH'});
	# 	die if ($check != $ENV{'CONTENT_LENGTH'});
	# 	$body = &sbtxt_linefeed($body);
	# 	$gIn{'charset'} = $2 if ($body =~ /^<\?xml(.*?)encoding=\"(.*?)\"(.*?)>/s);
	# 	$gIn{'methodName'} = $1 if ($body =~ /<methodName>(.*?)<\/methodName>/is);
	# 	$gIn{'params'} = $1 if ($body =~ /<params>(.*?)<\/params>/is);
	# }
	# ===============================================================================
}

sub sbxml_init {
	require 'mimeutil.pl';
	$gEnv{'xmlrpc'} = {
		'blogger.newPost'           => \&sbxml_blogger_newpost,
		'blogger.editPost'          => \&sbxml_blogger_editpost,
		'blogger.getRecentPosts'    => \&sbxml_blogger_getrecentposts,
		'blogger.getUsersBlogs'     => \&sbxml_blogger_getusersblogs,
		'blogger.getUserInfo'       => \&sbxml_blogger_getuserinfo,
		'blogger.deletePost'        => \&sbxml_blogger_deletepost,
		'metaWeblog.getPost'        => \&sbxml_metaweblog_getpost,
		'metaWeblog.newPost'        => \&sbxml_metaweblog_newpost,
		'metaWeblog.editPost'       => \&sbxml_metaweblog_editpost,
		'metaWeblog.getRecentPosts' => \&sbxml_metaweblog_getrecentposts,
		'metaWeblog.newMediaObject' => \&sbxml_metaweblog_newmediaobject,
		'mt.getCategoryList'        => \&sbxml_mt_getcategorylist,
		'mt.setPostCategories'      => \&sbxml_mt_setpostcategories,
		'mt.getPostCategories'      => \&sbxml_mt_getpostcategories,
		'mt.getRecentPostTitles'    => \&sbxml_mt_recentposttitles,
		'mt.supportedMethods'       => \&sbxml_mt_supportedmethods,
	};
	return();
}
sub sbxml_main {
	&sbxml_init();
	my @stack = ($gIn{'params'} =~ /<param>(.*?)<\/param>/sg);
	$gIn{'charset'} = 'UTF-8' if ($gIn{'charset'} eq ''); # ʸɲ
	&sbfile_read_datafile('user');
	if ($gEnv{'xmlrpc'}{$gIn{'methodName'}}) {
		&{$gEnv{'xmlrpc'}{$gIn{'methodName'}}}(@stack);
	} else {
		&sbxml_response(1,'Unknown method. [' . $gIn{'methodName'} . ']');
	}
}
sub sbxml_response {
	my ($code,$input) = @_;
	my $output = '';
	my $bgn = ($code) ? 'fault><value><struct' : 'params><param><value';
	my $end = ($code) ? 'struct></value></fault' : 'value></param></params';
	$output .= '<?xml version="1.0" encoding="UTF-8"?>' . "\n";
	$output .= '<methodResponse><' . $bgn . '>' . "\n";
	if ($code) {
		$output .= '<member><name>faultCode</name><value><int>' . $code . '</int></value></member>' . "\n";
		$output .= '<member><name>faultString</name><value><string>' . $input . '</string></value></member>' . "\n";
	} else {
		$output .= $input . "\n";
	}
	$output .= '</' . $end . '></methodResponse>' . "\n";
	my $len = length($output);
	print 'Content-length: ',$len,"\n";
	print 'Content-Type: text/xml',"\n";
	print "\n",$output;
	exit(0);
	# [顼ɰ] =============================================
	# 1. Unknown method.           : ̤ݡȥ᥽å
	# 2. Too many parameters.      : ѥ᡼¿
	# 3. Failed to authorize.      : ǧڤ˼Ԥ
	# 4. The entry does not exist. : ꤷȥ꡼¸ߤʤ
	# 5. Failed to lock a file.    : եå
	# 6. Failed to upload a file.  : åץɼ
	# 7. Permission denied.        : ¤ʤ
	# ================================================================
}
sub sbxml_blogger_newpost {
	my $app  = shift; # string (Ѥʤ)
	my $wid  = shift; # string (Ѥʤ)
	my $user = &sbxml_value(shift); # string
	my $pass = &sbxml_value(shift); # string
	my $body = &sbxml_value(shift); # string
	my $flag = &sbxml_value(shift); # boolean
	&sbxml_response(2,'Too many parameters.') if (@_);
	&sbxml_response(3,'Failed to authorize.') if (&sbini_checkpass($user,$pass));
	my $cont;
	$cont->{'description'} = $body;
	my $eid = &sbxml_edit_entry('',$cont,$flag);
	my $out = ($eid ne '') ? '<string>' . $eid . '</string>' : '<boolean>0</boolean>';
	&sbxml_response(0,$out);
}
sub sbxml_blogger_editpost {
	my $app  = shift;  # string (Ѥʤ)
	my $eid  = &sbxml_value(shift); # string
	my $user = &sbxml_value(shift); # string
	my $pass = &sbxml_value(shift); # string
	my $body = &sbxml_value(shift); # string
	my $flag = &sbxml_value(shift); # boolean
	&sbxml_response(2,'Too many parameters.') if (@_);
	&sbxml_response(3,'Failed to authorize.') if (&sbini_checkpass($user,$pass));
	my $cont;
	$cont->{'description'} = $body;
	$eid = &sbxml_edit_entry($eid,$cont,$flag);
	my $out = ($eid ne '') ? '<boolean>1</boolean>' : '<boolean>0</boolean>';
	&sbxml_response(0,$out);
}
sub sbxml_blogger_getrecentposts {
	my $app  = shift; # string (Ѥʤ)
	my $wid  = shift; # string (Ѥʤ)
	my $user = &sbxml_value(shift); # string
	my $pass = &sbxml_value(shift); # string
	my $num  = &sbxml_value(shift); # int
	&sbxml_response(2,'Too many parameters.') if (@_);
	&sbxml_response(3,'Failed to authorize.') if (&sbini_checkpass($user,$pass));
	my $out = '<array><data>' . "\n";
	my $cnt = 0;
	&sbfile_read_datafile('ent');
	@order = @{$gData{'ent'}};
	@order = sort { $$b{'date'} <=> $$a{'date'} } @order;
	foreach my $hash ( @order ) {
		next if ($$hash{'id'} eq '');
		$out .= '<value>' . &sbxml_entry_struct($$hash{'id'},2) . '</value>';
		delete($gData{'entry'}{$eid}); # Ѥȥ꡼ǡ
		$cnt++;
		last if ($cnt >= $num);
	}
	$out .= '</data></array>';
	&sbxml_response(0,$out);
}
sub sbxml_blogger_getusersblogs {
	my $app  = shift; # string (Ѥʤ)
	my $user = &sbxml_value(shift); # string
	my $pass = &sbxml_value(shift); # string
	&sbxml_response(2,'Too many parameters.') if (@_);
	&sbxml_response(3,'Failed to authorize.') if (&sbini_checkpass($user,$pass));
	my $out = '<array><data><value><struct>' . "\n";
	my $blog = $gEnv{'conf'}{'blog_title'};
	$blog = &sblang_conv($blog,'utf8',$gEnv{'code'}) if ($gEnv{'code'} ne 'utf8');
	$out .= '<member><name>url</name><value><string>' . $gEnv{'srv'}{'base'} . '</string></value></member>' . "\n";
	$out .= '<member><name>blogid</name><value><string>0</string></value></member>' . "\n";
	$out .= '<member><name>blogName</name><value><string>' . $blog . '</string></value></member>' . "\n";
	$out .= '</struct></value></data></array>';
	&sbxml_response(0,$out);
}
sub sbxml_blogger_getuserinfo {
	my $app  = shift; # string (Ѥʤ)
	my $user = &sbxml_value(shift); # string
	my $pass = &sbxml_value(shift); # string
	&sbxml_response(2,'Too many parameters.') if (@_);
	&sbxml_response(3,'Failed to authorize.') if (&sbini_checkpass($user,$pass));
	my $pid = $gEnv{'currentuser'};
	my $name = ($gData{'user'}[$pid]{'real'} ne '') ? $gData{'user'}[$pid]{'real'} : $gData{'user'}[$pid]{'name'};
	$name = &sblang_conv($name,'utf8',$gEnv{'code'}) if ($gEnv{'code'} ne 'utf8');
	my $out = '<struct>' . "\n";
	$out .= '<member><name>userid</name><value><string>' . $pid . '</string></value></member>' . "\n";
	$out .= '<member><name>firstname</name><value><string>' . (split(/\s+/,$name,2))[0] . '</string></value></member>' . "\n";
	$out .= '<member><name>lastname</name><value><string>' . (split(/\s+/,$name,2))[1] . '</string></value></member>' . "\n";
	$out .= '<member><name>nickname</name><value><string>' . $name . '</string></value></member>' . "\n";
	$out .= '<member><name>email</name><value><string>' . $gData{'user'}[$pid]{'mail'} . '</string></value></member>' . "\n";
	$out .= '<member><name>url</name><value><string>' . $gEnv{'srv'}{'base'} . '</string></value></member>' . "\n";
	$out .= '</struct>';
	&sbxml_response(0,$out);
}
sub sbxml_blogger_deletepost {
	my $app  = shift; # string (Ѥʤ)
	my $eid  = &sbxml_value(shift); # string
	my $user = &sbxml_value(shift); # string
	my $pass = &sbxml_value(shift); # string
	my $flag = shift; # boolean
	&sbxml_response(2,'Too many parameters.') if (@_);
	&sbxml_response(3,'Failed to authorize.') if (&sbini_checkpass($user,$pass));
	my $lfile = &sblock_lock() or &sbxml_response(5,'Failed to lock a file.');
	$gIn{'del' . $eid} = 'on';
	&sbadmn_delete_entry();
	&sblock_unlock($lfile);
	my $out = '<boolean>1</boolean>';
	&sbxml_response(0,$out);
}
sub sbxml_metaweblog_getpost {
	my $eid  = &sbxml_value(shift); # string
	my $user = &sbxml_value(shift); # string
	my $pass = &sbxml_value(shift); # string
	&sbxml_response(2,'Too many parameters.') if (@_);
	&sbxml_response(3,'Failed to authorize.') if (&sbini_checkpass($user,$pass));
	$eid = &sbxml_check_entry($eid);
	&sbxml_response(4,'The entry does not exist.') if ($eid eq '');
	my $out = &sbxml_entry_struct($eid,1);
	&sbxml_response(0,$out);
}
sub sbxml_metaweblog_newpost {
	my $wid  = shift; # string (Ѥʤ)
	my $user = &sbxml_value(shift); # string
	my $pass = &sbxml_value(shift); # string
	my $cont = &sbxml_value(shift); # struct
	my $flag = &sbxml_value(shift); # boolean
	&sbxml_response(2,'Too many parameters.') if (@_);
	&sbxml_response(3,'Failed to authorize.') if (&sbini_checkpass($user,$pass));
	my $eid = &sbxml_edit_entry('',$cont,$flag);
	my $out = ($eid ne '') ? '<string>' . $eid . '</string>' : '<boolean>0</boolean>';
	&sbxml_response(0,$out);
}
sub sbxml_metaweblog_editpost {
	my $eid  = &sbxml_value(shift); # string
	my $user = &sbxml_value(shift); # string
	my $pass = &sbxml_value(shift); # string
	my $cont = &sbxml_value(shift); # struct
	my $flag = &sbxml_value(shift); # boolean
	&sbxml_response(2,'Too many parameters.') if (@_);
	&sbxml_response(3,'Failed to authorize.') if (&sbini_checkpass($user,$pass));
	$eid = &sbxml_edit_entry($eid,$cont,$flag);
	my $out = ($eid ne '') ? '<boolean>1</boolean>' : '<boolean>0</boolean>';
	&sbxml_response(0,$out);
}
sub sbxml_metaweblog_getrecentposts {
	my $wid  = shift; # string (Ѥʤ)
	my $user = &sbxml_value(shift); # string
	my $pass = &sbxml_value(shift); # string
	my $num  = &sbxml_value(shift); # int
	&sbxml_response(2,'Too many parameters.') if (@_);
	&sbxml_response(3,'Failed to authorize.') if (&sbini_checkpass($user,$pass));
	my $out = '<array><data>' . "\n";
	my $cnt = 0;
	&sbfile_read_datafile('ent');
	@order = @{$gData{'ent'}};
	@order = sort { $$b{'date'} <=> $$a{'date'} } @order;
	foreach my $hash ( @order ) {
		next if ($$hash{'id'} eq '');
		$out .= '<value>' . &sbxml_entry_struct($$hash{'id'},1) . '</value>';
		delete($gData{'entry'}{$eid}); # Ѥȥ꡼ǡ
		$cnt++;
		last if ($cnt >= $num);
	}
	$out .= '</data></array>';
	&sbxml_response(0,$out);
}
sub sbxml_metaweblog_newmediaobject {
	my $wid  = shift; # string (Ѥʤ)
	my $user = &sbxml_value(shift); # string
	my $pass = &sbxml_value(shift); # string
	my $file = &sbxml_value(shift); # struct
	&sbxml_response(2,'Too many parameters.') if (@_);
	&sbxml_response(3,'Failed to authorize.') if (&sbini_checkpass($user,$pass));
	if ($file and $file->{'name'} and $file->{'bits'} ne '') {
		$gIn{'upload_thumb'} = 'on' if ( $gEnv{'conf'}{'thumbcheck'} );
		my $field = 'upload_file:';
		$field .= ' Content-Type:' . $file->{'type'}  . ';' if ($file->{'type'} ne '');
		$field .= ' filename=' . $file->{'name'};
		push(@gIn,$field);
		$gIn{'upload_file'} = $file->{'bits'};
	}
	my $lfile = &sblock_lock() or &sbxml_response(5,'Failed to lock a file.');
	&sbfile_read_datafile('img');
	my $num = $gData{'num'}{'img'};
	&sbadmn_update_image();
	&sblock_unlock($lfile);
	my $out = '';
	my $id = $gData{'img'}[$num]{'id'};
	if ($id ne '') {
		$out = '<string>' . $gEnv{'srv'}{'base'} . $gEnv{'dir'}{'img'} . $gData{'img'}[$id]{'file'} . '</string>';
	} else {
		&sbxml_response(6,'Failed to upload a file.');
	}
	&sbxml_response(0,$out);
}
sub sbxml_mt_getcategorylist {
	my $wid  = shift; # string (Ѥʤ)
	my $user = &sbxml_value(shift); # string
	my $pass = &sbxml_value(shift); # string
	&sbxml_response(2,'Too many parameters.') if (@_);
	&sbxml_response(3,'Failed to authorize.') if (&sbini_checkpass($user,$pass));
	my $out = '<array><data>' . "\n";
	&sbfile_read_datafile('cat');
	my @order = @{$gData{'cat'}};
	@order = sort { $$a{'order'} <=> $$b{'order'} } @order;
	foreach my $cat (@order) {
		next if ($$cat{'id'} eq '');
		$$cat{'name'} = &sblang_conv($$cat{'name'},'utf8',$gEnv{'code'}) if ($gEnv{'code'} ne 'utf8');
		$out .= '<value><struct>';
		$out .= '<member><name>categoryId</name><value><string>' . $$cat{'id'} . '</string></value></member>';
		$out .= '<member><name>categoryName</name><value><string>' . $$cat{'name'} . '</string></value></member>';
		$out .= '</struct></value>' . "\n";
		if ($$cat{'sub'} ne '') {
			my @subs = split(':',$$cat{'sub'});
			for (my $i=0;$i<@subs;$i++) {
				$subs[$i] = &sblang_conv($subs[$i],'utf8',$gEnv{'code'}) if ($gEnv{'code'} ne 'utf8');
				$out .= '<value><struct>';
				$out .= '<member><name>categoryId</name><value><string>' . $$cat{'id'} . '-' . $subs[$i] . '</string></value></member>';
				$out .= '<member><name>categoryName</name><value><string>' . $$cat{'name'} . '(' . $subs[$i] . ')</string></value></member>';
				$out .= '</struct></value>' . "\n";
			}
		}
	}
	$out .= '</data></array>';
	&sbxml_response(0,$out);
}
sub sbxml_mt_setpostcategories {
	my $eid  = &sbxml_value(shift); # string
	my $user = &sbxml_value(shift); # string
	my $pass = &sbxml_value(shift); # string
	my $cat  = &sbxml_value(shift); # array [ struct ]
	&sbxml_response(2,'Too many parameters.') if (@_);
	&sbxml_response(3,'Failed to authorize.') if (&sbini_checkpass($user,$pass));
	my $out = '<boolean>';
	if ($cat) {
		my $lfile = &sblock_lock() or &sbxml_response(5,'Failed to lock a file.');
		$eid = &sbxml_check_entry($eid);
		if ($eid ne '') {
			&sbfile_read_datafile('cat');
			my $flag = 0;
			foreach my $cat_el (@{$cat}) {
				my $id = int($cat_el->{'categoryId'});
				next if (!$cat_el->{'isPrimary'});
				next if ($gData{'cat'}[$id]{'id'} eq '');
				my $ent_cat = $gData{'cat'}[$id]{'name'};
				my $subname = '';
				if ($cat_id =~ /^(\d+?)\-(.*)/) {
					$subname = &sbtxt_decform($2,1,$gEnv{'code'});
				}
				$subname =~ s/\:/\&\#58;/g;
				$ent_cat .= '->' . $subname if ($subname ne '');
				$gData{'ent'}[$eid]{'cat'} = $ent_cat;
				$flag = 1;
				last; # ץ饤ޥꥫƥ꡼ʤΤȴ
			} # end of foreach
			if (!$flag) { # isPrimary åȤƤʤ
				my $cat_el = $cat->[0];
				my $id = int($cat_el->{'categoryId'});
				if ($gData{'cat'}[$id]{'id'} ne '') {
					my $ent_cat = $gData{'cat'}[$id]{'name'};
					my $subname = '';
					if ($cat_id =~ /^(\d+?)\-(.*)/) {
						$subname = &sbtxt_decform($2,1,$gEnv{'code'});
					}
					$subname =~ s/\:/\&\#58;/g;
					$ent_cat .= '->' . $subname if ($subname ne '');
					$gData{'ent'}[$eid]{'cat'} = $ent_cat;
					$flag = 1;
				}
			} # end of $flag
			&sbfile_update_datafile('ent');
			&sblock_unlock($lfile);
			$out .= $flag; # ƥ꡼ȥåȤ줿 1 ֤
		} else { # $eid
			&sblock_unlock($lfile);
			&sbxml_response(4,'The entry does not exist.');
		} # end of $eid
	} else { # $cat
		$out .= '0';
	} # end of $cat
	$out .= '</boolean>';
	&sbxml_response(0,$out);
}
sub sbxml_mt_getpostcategories {
	my $eid  = &sbxml_value(shift); # string
	my $user = &sbxml_value(shift); # string
	my $pass = &sbxml_value(shift); # string
	&sbxml_response(2,'Too many parameters.') if (@_);
	&sbxml_response(3,'Failed to authorize.') if (&sbini_checkpass($user,$pass));
	$eid = &sbxml_check_entry($eid);
	&sbxml_response(4,'The entry does not exist.') if ($eid eq '');
	my $out = '<array><data>' . "\n";
	if ($gData{'ent'}[$eid]{'cat'}) {
		&sbfile_read_datafile('cat');
		my @cat = &sbcms_entry_cattext($gData{'ent'}[$eid]{'cat'});
		my $id = &sbcms_entry_catid($gData{'ent'}[$eid]{'cat'});
		$cat[1] = &sblang_conv($cat[1],'utf8',$gEnv{'code'}) if ($cat[1] ne ''  and $gEnv{'code'} ne 'utf8');
		$cat[2] = &sblang_conv($cat[2],'utf8',$gEnv{'code'}) if ($gEnv{'code'} ne 'utf8');
		my $cid = ($cat[1] eq '') ? $id : $id . '-' . $cat[1];
		$out .= '<value><struct>' . "\n";
		$out .= '<member><name>categoryId</name><value><string>' . $cid . '</string></value></member>' . "\n";
		$out .= '<member><name>categoryName</name><value><string>' . $cat[2] . '</string></value></member>' . "\n";
		$out .= '<member><name>isPrimary</name><value><boolean>1</boolean></value></member>' . "\n";
		$out .= '</struct></value>' . "\n";
	} else {
		$out .= '<value><struct>' . "\n";
		$out .= '<member><name>categoryId</name><value><string></string></value></member>' . "\n";
		$out .= '<member><name>categoryName</name><value><string></string></value></member>' . "\n";
		$out .= '<member><name>isPrimary</name><value><boolean>1</boolean></value></member>' . "\n";
		$out .= '</struct></value>' . "\n";
	}
	$out .= '</data></array>';
	&sbxml_response(0,$out);
}
sub sbxml_mt_recentposttitles {
	my $wid  = shift; # string (Ѥʤ)
	my $user = &sbxml_value(shift); # string
	my $pass = &sbxml_value(shift); # string
	my $num  = &sbxml_value(shift); # int
	&sbxml_response(2,'Too many parameters.') if (@_);
	&sbxml_response(3,'Failed to authorize.') if (&sbini_checkpass($user,$pass));
	my $out = '<array><data>' . "\n";
	my $cnt = 0;
	&sbfile_read_datafile('ent');
	@order = @{$gData{'ent'}};
	@order = sort { $$b{'date'} <=> $$a{'date'} } @order;
	foreach my $hash ( @order ) {
		next if ($$hash{'id'} eq '');
		$out .= '<value>' . &sbxml_entry_struct($$hash{'id'},0) . '</value>';
		delete($gData{'entry'}{$eid}); # Ѥȥ꡼ǡ
		$cnt++;
		last if ($cnt >= $num);
	}
	$out .= '</data></array>';
	&sbxml_response(0,$out);
}
sub sbxml_mt_supportedmethods {
	&sbxml_response(2,'Too many parameters.') if (@_);
	my $out = '<array><data>' . "\n";
	foreach my $meth ( keys(%{$gEnv{'xmlrpc'}}) ) {
		next if ($meth eq 'mt.supportedMethods');
		$out .= '<value><string>' . $meth . '</string></value>' . "\n";
	}
	$out .= '</data></array>';
	&sbxml_response(0,$out);
}
sub sbxml_check_entry {
	my $eid = shift;
	my $user = $gEnv{'currentuser'};
	&sbfile_read_datafile('ent');
	if ($eid ne '') {
		$eid = int($eid);
		$eid = '' if ($gData{'ent'}[$eid]{'id'} eq '');
		$eid = '' if ($eid ne '' and $gData{'ent'}[$eid]{'auth'} ne $user and $gData{'user'}[$user]{'stat'} > 1); # ¥å
	}
	return($eid);
}
sub sbxml_edit_entry {
	my ($eid,$cont,$flag) = @_;
	my $lfile = &sblock_lock() or &sbxml_response(5,'Failed to lock a file.');
	if ($eid ne '') { # ȥ꡼å
		$eid = &sbxml_check_entry($eid);
		if ($eid eq '') {
			&sblock_unlock($lfile);
			&sbxml_response(7,'Permission denied.');
		}
	}
	foreach my $elem ('title','mt_keywords','mt_allow_comments','mt_allow_pings','mt_convert_breaks') {
		$cont->{$elem} =~ tr/\x0D\x0A//d; # ԥɽ
	}
	$gIn{'entry_title'}   = &sbtxt_det($cont->{'title'});
	$gIn{'entry_body'}    = &sbtxt_det($cont->{'description'});
	$gIn{'entry_more'}    = &sbtxt_det($cont->{'mt_text_more'});
	$gIn{'entry_summary'} = &sbtxt_det($cont->{'mt_excerpt'});
	$gIn{'entry_keyword'} = &sbtxt_det($cont->{'mt_keywords'});
	$gIn{'entry_com'} = $cont->{'mt_allow_comments'};
	$gIn{'entry_tb'} = $cont->{'mt_allow_pings'};
	$gIn{'entry_format'} = $cont->{'mt_convert_breaks'};
	if ($cont->{'dateCreated'}) {
		$gIn{'entry_date_sc'} = $cont->{'dateCreated'}->{'sc'};
		$gIn{'entry_date_mi'} = $cont->{'dateCreated'}->{'mi'};
		$gIn{'entry_date_ho'} = $cont->{'dateCreated'}->{'ho'};
		$gIn{'entry_date_dy'} = $cont->{'dateCreated'}->{'dy'};
		$gIn{'entry_date_mo'} = $cont->{'dateCreated'}->{'mo'};
		$gIn{'entry_date_yr'} = $cont->{'dateCreated'}->{'yr'};
		$gEnv{'conf'}{'timezone'} = '+0000';
	} else {
		my $zone = &sbtime_zone($gEnv{'conf'}{'timezone'});
		my ($se,$mi,$ho,$md,$mo,$ye,$wd,$yd,$is) = gmtime($gNowTime + $zone);
		$gIn{'entry_date_sc'} = $se;
		$gIn{'entry_date_mi'} = $mi;
		$gIn{'entry_date_ho'} = $ho;
		$gIn{'entry_date_dy'} = $md;
		$gIn{'entry_date_mo'} = $mo + 1;
		$gIn{'entry_date_yr'} = $ye + 1900;
	}
	if ($cont->{'mt_tb_ping_urls'}) {
		$gIn{'entry_tbping'} = '';
		foreach my $ping (@{$cont->{'mt_tb_ping_urls'}}) {
			$gIn{'entry_tbping'} .= $ping . "\n";
		}
	}
	if ($gData{'user'}[$gEnv{'currentuser'}]{'cat'} ne '' or $eid ne '') {
		&sbfile_read_datafile('cat');
		my $current = $gData{'user'}[$gEnv{'currentuser'}]{'cat'};
		$current = $gData{'ent'}[$eid]{'cat'} if ($eid ne '');
		my @cat = &sbcms_entry_cattext($current);
		my $id = &sbcms_entry_catid($cat[0]);
		$cat[1] = &sblang_conv($cat[1],'utf8',$gEnv{'code'}) if ($cat[1] ne ''  and $gEnv{'code'} ne 'utf8');
		my $cid = ($cat[1] eq '') ? $id : $id . '-' . $cat[1];
		$gIn{'entry_category'} = $cid;
	}
	$gIn{'open_save'} = ($flag) ? 'open' : '';
	my $msg = &sbadmn_update_entry($eid);
	&sblock_unlock($lfile);
	if ($msg eq $gMsg{'error'}{'no_body'}) {
		$msg = &sblang_conv($msg,'utf8',$gEnv{'code'}) if ($gEnv{'code'} ne 'utf8');
		&sbxml_response(5,$msg);
	}
	return($gIn{'eid'});
}
sub sbxml_entry_struct {
	my ($eid,$mode) = @_;
	my $user = $gEnv{'currentuser'};
	my $out = '';
	$eid = '' if ($eid ne '' and $gData{'ent'}[$eid]{'auth'} ne $user and $gData{'user'}[$user]{'stat'} > 1); # ¥å
	return() if ($eid eq '');
	&sbfile_read_entry($eid);
	my $hash = $gData{'entry'}{$eid}{'ent'};
	my $date = &sbtime_stamp($$hash{'date'},'%yr%mo%dyT%hr:%mi:%sc','+0000','en');
	my $subj = $$hash{'subj'};
	$subj = &sblang_conv($subj,'utf8',$gEnv{'code'}) if ($gEnv{'code'} ne 'utf8');
	$out .= '<struct>' . "\n";
	$out .= '<member><name>userid</name><value><string>' . $$hash{'auth'} . '</string></value></member>' . "\n";
	$out .= '<member><name>dateCreated</name><value><dateTime.iso8601>' . $date . '</dateTime.iso8601></value></member>' . "\n";
	$out .= '<member><name>postid</name><value><string>' . $eid . '</string></value></member>' . "\n";
	$out .= '<member><name>title</name><value><string>' . $subj . '</string></value></member>' . "\n" if ($mode < 2);
	if ($mode) {
		my $body = &sbtxt_lfconv($$hash{'body'},1);
		$body = &sblang_conv($body,'utf8',$gEnv{'code'}) if ($gEnv{'code'} ne 'utf8');
		if ($mode == 2) { # for [blogger.getRecentPosts]
			$out .= '<member><name>content</name><value><string>' . $body . '</string></value></member>' . "\n";
		} else {
			my $aDescLen = 200; # פĹ
			my $more = &sbtxt_lfconv($$hash{'more'},1);
			my $word = &sbtxt_lfconv($$hash{'key'},1);
			my $sum  = &sbcms_make_summary($$hash{'sum'},$$hash{'body'},$aDescLen);
			if ($gEnv{'code'} ne 'utf8') {
				$more = &sblang_conv($more,'utf8',$gEnv{'code'});
				$word = &sblang_conv($word,'utf8',$gEnv{'code'});
				$sum  = &sblang_conv($sum,'utf8',$gEnv{'code'});
			}
			$out .= '<member><name>description</name><value><string>' . $body . '</string></value></member>' . "\n";
			$out .= '<member><name>mt_text_more</name><value><string>' . $more . '</string></value></member>' . "\n";
			$out .= '<member><name>mt_keywords</name><value><string>' . $word . '</string></value></member>' . "\n";
			$out .= '<member><name>mt_excerpt</name><value><string>' . $sum . '</string></value></member>' . "\n";
			my $parmlink = &sbcms_permalink($eid,$$hash{'date'});
			$out .= '<member><name>link</name><value><string>' . $parmlink . '</string></value></member>' . "\n";
			$out .= '<member><name>permaLink</name><value><string>' . $parmlink . '</string></value></member>' . "\n";
			$out .= '<member><name>mt_allow_comments</name><value><string>' . $$hash{'acm'} . '</string></value></member>' . "\n";
			$out .= '<member><name>mt_allow_pings</name><value><string>' . $$hash{'atb'} . '</string></value></member>' . "\n";
			$out .= '<member><name>mt_convert_breaks</name><value><string>' . $$hash{'form'} . '</string></value></member>' . "\n";
		}
	}
	$out .= '</struct>' . "\n";
	return($out);
}
sub sbxml_value {
	my $value = shift;
	my $output;
	$value =~ s/<value>(.*)<\/value>/$1/sg; # value ȴФ
	$value =~ s/^[\s|\n]*(.*)[\s|\n]*$/$1/s; # Ǥ
	TYPE_SWITCH: {
		$_ = $value;
		/^<int>/ && do {
			if ($value =~ /<int>(.*)<\/int>/s) {
				$output = int($1) ;
				return($output);
			}
			last TYPE_SWITCH;
		};
		/^<i4>/ && do {
			if ($value =~ /<i4>(.*)<\/i4>/s) {
				$output = int($1) ;
				return($output);
			}
			last TYPE_SWITCH;
		};
		/^<boolean>/ && do {
			if ($value =~ /<boolean>(.*)<\/boolean>/s) {
				$output = int($1) ;
				return($output);
			}
			last TYPE_SWITCH;
		};
		/^<double>/ && do {
			if ($value =~ /<double>(.*)<\/double>/s) {
				$output = $1 ;
				return($output);
			}
			last TYPE_SWITCH;
		};
		/^<dateTime\.iso8601>/ && do {
			$output = $1 if ($value =~ /<dateTime\.iso8601>(.*)<\/dateTime\.iso8601>/s);
			if ($output =~ /(\d\d\d\d)-?(\d\d)-?(\d\d)T(\d\d):(\d\d):(\d\d)/) {
				$output->{'yr'} = $1;
				$output->{'mo'} = $2;
				$output->{'dy'} = $3;
				$output->{'ho'} = $4;
				$output->{'mi'} = $5;
				$output->{'sc'} = $6;
			} else {
				$output = '';
			}
			return($output);
		};
		/^<base64>/ && do {
			if ($value =~ /<base64>(.*)<\/base64>/s) {
				$output = $1;
				$output =~ s/\s/+/g;
				$output =~ s/(.{76})/$1\n/g;
				$output = &mimeutil::bodydecode($output,'b64');
				return($output);
			}
			last TYPE_SWITCH;
		};
		/^<struct>/ && do {
			if ($value =~ /<struct>(.*)<\/struct>/s) {
				$output = &sbxml_struct($1);
				return($output);
			}
			last TYPE_SWITCH;
		};
		/^<array>/ && do {
			if ($value =~ /<data>(.*)<\/data>/s) {
				$output = &sbxml_array($1);
				return($output);
			}
			last TYPE_SWITCH;
		};
		/^<string>/ && do {
			if ($value =~ /<string>(.*)<\/string>/s) {
				$output = $1 ;
				return($output);
			}
			last TYPE_SWITCH;
		};
	}
	$output = $value if (!$output);
	return($output);
}
sub sbxml_struct {
	my $input = shift;
	my $output;
	my @stack = ($input =~ /<member>(.*?)<\/member>/sg); # Դ
	foreach my $member (@stack) {
		if ($member =~ /<name>(.*?)<\/name>.*<value>(.*?)<\/value>/s) {
			my $name = $1;
			my $value = $2;
			$output->{$name} = &sbxml_value($value);
		}
	}
	return($output);
}
sub sbxml_array {
	my $input = shift;
	my $output;
	my $flag = 0;
	if ($input =~ /<value>[\s|\n]*<struct>/) { # struct in array ?
		my @stack = ($input =~ /<value>[\s|\n]*<struct>(.*?)<\/struct>[\s|\n]*<\/value>/sg); # Դ
		foreach my $value (@stack) {
			push(@{$output},&sbxml_struct($value));
		}
	} else {
		my @stack = ($input =~ /<value>(.*?)<\/value>/sg); # Դ
		foreach my $value (@stack) {
			push(@{$output},&sbxml_value($value));
		}
	}
	return($output);
}
1;
